Attribute VB_Name = "Get_Desktop_Dir"
'http://support.microsoft.com/support/kb/articles/Q191/1/98.ASP
'To use this module, you have to make a reference to
'ITMalloc.tlb in your Project and have it in
'your System directory. The Call is Get_Dsktop_Path
'and the result is TrueDesktopPath.
'ITMalloc.tlb (3K) (Obtained from MS site above)- The type library required to expose
'the Free method of the IMalloc operating system object.

Option Explicit
Option Base 1
    Public FolderPath As String * 300
    Public DesktopPath As String ' Bunch of junk at end of this file-probably vbcrlf but I am not sure
    Public TrueDesktopPath 'DesktopPath without the extra non-printable characters

'See Q191198 at http://support.microsoft.com/support/kb/articles/q191/1/98.asp?LNG=ENG&SA=ALLKB
Private Declare Function SHGetSpecialFolderLocation Lib "shell32" _
                     (ByVal hwnd As Long, _
                     ByVal nFolder As Long, _
                     Pidl As Long) As Long
' This function retrieves the PIDL of a special folder. This function returns NOERROR
' if successful, or an OLE-defined error result otherwise. The function requires the
' following parameters:
'
'     hwnd- long handle to the owner window the client should specify if it displays a
'           dialog box or message box. Use zero for this value
'     nFolder- long constant that specifies the special folder. The constant values are
'              the index numbers of the Special folders combo box.
'     Pidl-    a pointer to the pointer of the special folder.

Private Declare Function SHGetPathFromIDList Lib "shell32" _
                     (Pidl As Long, _
                     ByVal FolderPath As String) As Long
' This function converts an item identifier list to a file system path. The function
' returns TRUE if successful, or FALSE otherwise. The function requires the following
' parameters:
'
'     Pidl-       a pointer to the pointer of the special folder
'     FolderPath- a string buffer to receive the file system path. This buffer contains
'                 the directory path.

Private Declare Function SHGetMalloc Lib "shell32" (lpMalloc As ITMalloc) As Long  '(SHOULD BE IN - & ADD REFERENCE TO ITMALLOC.TLB)
' This function is used to free the memory allocated by the SHGetSpecialFolderLocation
' and the SHGetPathFromIDList functions. This function requires a pointer to the
' Free method of the IMalloc operating system object. To expose this method to
' Visual Basic, you need a reference to the ITMalloc .tlb type library enclosed with this
' sample project.
Const CSIDL_DESKTOP = 0
Public Sub Get_Dsktop_Path()
   Dim hResult As Long
   Dim bResult As Long
   Dim Pidl As Long
   Dim ShellMalloc As ITMalloc  '(SHOULD BE IN)
   Dim SubItem2 'hnc
   Dim nFolder As Long
   nFolder = CSIDL_DESKTOP
      hResult = SHGetSpecialFolderLocation(0, nFolder, Pidl)
   If hResult = 0 Then
      'SHGetPathFromIDList only works with special folders that exist on a hard drive
      'For example, "CSIDL_DRIVES" means "My Computer" which is not a folder on any drive
      'Windows NT has a different set of special folders than Windows 95
      bResult = SHGetPathFromIDList(ByVal Pidl, FolderPath)
      hResult = SHGetMalloc(ShellMalloc)  ' (SHOULD BE IN)
     ShellMalloc.Free Pidl  ' (SHOULD BE IN)
     Set ShellMalloc = Nothing  ' (SHOULD BE IN)
      If bResult = 1 Then
        DesktopPath = Trim(FolderPath)
      Else
        MsgBox "Desktop Directory NOT found", vbOKOnly, "Error"
      End If
     Else
        MsgBox "Desktop Directory NOT found", vbOKOnly, "Error"
   End If
   Get_True_Path
End Sub

Public Sub Get_True_Path()
Dim TestChar, x

For x = 1 To Len(DesktopPath)
TestChar = UCase(Mid(DesktopPath, x, 1))
If (Asc(TestChar) < 32 Or Asc(TestChar) > 92) And Not IsNumeric(TestChar) Then
TrueDesktopPath = Mid(DesktopPath, 1, (x - 1))
Exit Sub
End If
Next x

End Sub
